// DlgProxy.cpp : implementation file
//

#include "stdafx.h"
#include "MFCDemoPdx.h"
#include "DlgProxy.h"
#include "MFCDemoPdxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMFCDemoPdxDlgAutoProxy

IMPLEMENT_DYNCREATE(CMFCDemoPdxDlgAutoProxy, CCmdTarget)

CMFCDemoPdxDlgAutoProxy::CMFCDemoPdxDlgAutoProxy()
{
	EnableAutomation();
	
	// To keep the application running as long as an automation 
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT_VALID(AfxGetApp()->m_pMainWnd);
	if (AfxGetApp()->m_pMainWnd)
	{
		ASSERT_KINDOF(CMFCDemoPdxDlg, AfxGetApp()->m_pMainWnd);
		if (AfxGetApp()->m_pMainWnd->IsKindOf(RUNTIME_CLASS(CMFCDemoPdxDlg)))
		{
			m_pDialog = reinterpret_cast<CMFCDemoPdxDlg*>(AfxGetApp()->m_pMainWnd);
			m_pDialog->m_pAutoProxy = this;
		}
	}
}

CMFCDemoPdxDlgAutoProxy::~CMFCDemoPdxDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != NULL)
		m_pDialog->m_pAutoProxy = NULL;
	AfxOleUnlockApp();
}

void CMFCDemoPdxDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CMFCDemoPdxDlgAutoProxy, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CMFCDemoPdxDlgAutoProxy, CCmdTarget)
END_DISPATCH_MAP()

// Note: we add support for IID_IMFCDemoPdx to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the 
//  dispinterface in the .IDL file.

// {F361DB97-CEED-4208-8577-6E18F7E9AD63}
static const IID IID_IMFCDemoPdx =
{ 0xF361DB97, 0xCEED, 0x4208, { 0x85, 0x77, 0x6E, 0x18, 0xF7, 0xE9, 0xAD, 0x63 } };

BEGIN_INTERFACE_MAP(CMFCDemoPdxDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CMFCDemoPdxDlgAutoProxy, IID_IMFCDemoPdx, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in StdAfx.h of this project
// {B17919EB-9429-490B-AFEE-6A03CE9AE598}
IMPLEMENT_OLECREATE2(CMFCDemoPdxDlgAutoProxy, "MFCDemoPdx.Application", 0xb17919eb, 0x9429, 0x490b, 0xaf, 0xee, 0x6a, 0x3, 0xce, 0x9a, 0xe5, 0x98)


// CMFCDemoPdxDlgAutoProxy message handlers
